/*
 * Citadel/UX  
 *
 * citadel.c - Main source file.
 *
 */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#include <termio.h>
#define CITADEL_C
#include "citadel.h"

#define IFEXPERT if (usersupp.flags&US_EXPERT)
#define IFNEXPERT if ((usersupp.flags&US_EXPERT)==0)
#define IFAIDE if (usersupp.axlevel>=6)
#define IFNAIDE if (usersupp.axlevel<6)
struct passwd *getpwuid();
struct passwd *getpwnam();
char *getenv();
long atol();
long lseek();
long finduser();

char fullname[100];
struct usersupp usersupp;		/* Logged-in user's user supp */
struct quickroom quickroom,QRscratch;	/* Current room and scratch   */
struct fullroom fullroom;		/* Current room               */
struct smreturn smreturn;		/* For returning message numbers */
struct msgmain msgmain;			/* Global message info           */
struct passwd *passwd;
int curr_rm;				/* Room NUMBER of current room.  */
int hold_rm;				/* Temporary room number */
					/* 0=Lobby 1=Mail 2=Aide 3-up=other */
char newnow;
char upass;				/* Nonzero if pw is managed by UNIX */
long yourpos;				/* position of your usersupp record */
char temp[50];				/* Name of general temp file */
int twitroom;				/* Room num of TWIT room (if enabled) */
struct termio stty0;			/* holds old termio settings */
jmp_buf nextbuf;
int ugnum; long uglsn;			/* holds <u>ngoto info */

int (*backnext())() {
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	longjmp(nextbuf,1);
	}

int (*backstop())() {
	signal(SIGQUIT,SIG_IGN);
	signal(SIGINT,SIG_IGN);
	longjmp(nextbuf,2);
	}

int (*sleeping())() {
	struct calllog rtmp;
	printf("Sleeping? Call again.\n");
	strcpy(rtmp.CLfullname,ttyname(0));
	rtmp.CLflags=CL_SLEEPING;
	rec_log(&rtmp);
	logoff(1); }

int (*dropcarr())() {
	struct calllog rtmp;
	strcpy(rtmp.CLfullname,ttyname(0));
	rtmp.CLflags=CL_DROPCARR;
	rec_log(&rtmp);
	logoff(SIGHUP);
}

inkey() {
	int a;
	signal(SIGALRM,(*sleeping));
	alarm(SLEEPING);
	a=getc(stdin); if (a==127) a=8;
	signal(SIGALRM,SIG_IGN);
	return(a);
	}

setsane() {
	ioctl(0,TCSETA,&stty0);
	}

char *months[12]={
	"Jan","Feb","Mar","Apr","May","Jun",
	"Jul","Aug","Sep","Oct","Nov","Dec" };

char *axdefs[7]={
	"Marked for deletion",
	"New User",
	"Problem User",
	"Local User",
	"Network User",
	"Preferred User",
	"Aide"
	};

formout(name) /* display a file using the formatter */
char name[]; {
char aaa[100]; int a;
	strcpy(aaa,name);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	if (setjmp(nextbuf)!=0) { sttybbs(0); return(1); }
	signal(SIGINT,(*backnext));
	signal(SIGQUIT,(*backstop));
	sttybbs(1);
	fmout(usersupp.screenwidth,aaa);
	sttybbs(0);
	return(0);
}

userlist() /* prints the userlist */ {
	sttybbs(1);
	system("userlist");
	sttybbs(0);
	}

readmail()
{
	int a;
	readyerself();
	for (a=0; a<MSGSPERRM; ++a) {
		fullroom.FRnum[a]=0L;
		fullroom.FRpos[a]=0L; }
	for (a=0; a<MAILSLOTS; ++a) {
		fullroom.FRnum[a+(MSGSPERRM-MAILSLOTS)]=usersupp.mailnum[a];
		fullroom.FRpos[a+(MSGSPERRM-MAILSLOTS)]=usersupp.mailpos[a]; }
	return(0);
	}

writemail()
{
	int a;
	readyerself();
	for (a=0; a<MAILSLOTS; ++a) {
		usersupp.mailnum[a]=fullroom.FRnum[a+(MSGSPERRM-MAILSLOTS)];
		usersupp.mailpos[a]=fullroom.FRpos[a+(MSGSPERRM-MAILSLOTS)]; }
	writeyerself();
	return(0);
	}

readyerself()
{
	int file;
	file=eopen("usersupp",O_RDONLY);
	lseek(file,yourpos,0);
	do {
	       read(file,&usersupp,sizeof(struct usersupp));
	    if (strucmp(fullname,usersupp.fullname)) finduser(file,fullname);
		} while(strucmp(fullname,usersupp.fullname));
	close(file);
	return(0);
	}

writeyerself()
{
	int file;
	struct usersupp me;
	file=eopen("usersupp",O_RDWR);
	lseek(file,yourpos,0);
	read(file,&me,sizeof(struct usersupp));
if (me.eternal!=usersupp.eternal) yourpos=finduser(file,usersupp.fullname);
	lseek(file,yourpos,0);
	write(file,&usersupp,sizeof(struct usersupp));
	close(file);
	return(0);
	}

main()
{
int a,b,c,d,e,f,file,file2;
long aa,cc;
char buf[300];
char aaa[100],bbb[100],ccc[100],eee[100];	/* general purpose variables */
char skipping[MAXROOMS];
struct usersupp tempUS;
struct calllog calllog;
struct wtmpsupp wtmpsupp;
char mtsflag,twit;

chdir(BBSDIR);			/* go to the right directory */
ioctl(0,TCGETA,&stty0);		/* Store the old terminal parameters and */
sttybbs(0);			/* install the new ones                  */
signal(SIGINT,SIG_IGN);
signal(SIGQUIT,SIG_IGN);
signal(SIGHUP,(*dropcarr));	/* Cleanup gracefully if carrier is dropped */
printf("\nCitadel/UX release 3.01-1d\n");
twit=0;				/* By default, user is not a problem user */
usersupp.screenwidth=80;
formout("messages/hello");	/* print the opening greeting */

log_carr();
a=getuid();
passwd=(struct passwd *)getpwuid(a);
strcpy(fullname,passwd->pw_gecos);
upass=1; if (a==BBSUID) upass=0;

twitroom=(-1);
GSTA:	newnow=0; if (upass==0) {		/* guest account - find out */
GSTB:		printf("Enter your name: ");	/* who the user is          */
		getline(fullname,29);
		strproc(fullname);
		if (!strucmp(fullname,"bbs")) goto GSTB;
		if (!strucmp(fullname,"new")) goto GSTB;
		if (!strucmp(fullname,"off")) goto TERMINATE;
		if (strlen(fullname)==0) goto GSTB;
		}

			/* get the usersupp data for guest account */
	file=eopen("usersupp",O_RDONLY);
	yourpos=finduser(file,fullname);
	if (yourpos==(-1L)) { close(file); goto NEWUSR; }
	read(file,&usersupp,sizeof(struct usersupp));
	close(file);
	goto USOK;

NEWUSR:	if (upass==0) {
		printf("No record. Enter as new user? ");
		if (yesno()==0) goto GSTA;
		}

	/* Initialize a new account */
	usersupp.USuid=getuid();
	strcpy(usersupp.fullname,fullname);
	for (a=0; a<MAXROOMS; ++a) {	usersupp.lastseen[a]=0L;
					usersupp.generation[a]=(-1);
					usersupp.forget[a]=(-1); }
	for (a=0; a<MAILSLOTS; ++a) {	usersupp.mailnum[a]=0L;
					usersupp.mailpos[a]=0L; }
	usersupp.flags=0;
	usersupp.timescalled=0;
	usersupp.posted=0;
	usersupp.axlevel=INITAX;
	time(&aa);
	usersupp.lastcall=aa;
	getusinfo(&usersupp);
	
	if (upass==0) {
		IFNEXPERT formout("messages/changepw");
		printf("Please enter a password: ");
		getline(usersupp.password,19);
		strproc(usersupp.password);
		pwcrypt(usersupp.password,PWCRYPT);
		newnow=1;
		}

	file=eopen("eternal",O_RDWR);	/* get a new user number */
	read(file,&aa,4);
	usersupp.eternal=aa;
	aa=aa+1L;
	lseek(file,0L,0);
	write(file,&aa,4);
	close(file);

	formout("messages/newuser");
	printf("  (setting up an account. please wait)\n");
						/* Add user to the        */
	file=eopen("usersupp",O_RDONLY);	/* usersupp file, keeping */
	file2=creat("/tmp/usersupp",0666);	/* the file in            */
	b=0;					/* alphabetical order     */
	do {
		a=read(file,&tempUS,sizeof(struct usersupp));
		if ( (strucmp(usersupp.fullname,tempUS.fullname)<0) ||(a<1)) {
			if (b==0)write(file2,&usersupp,sizeof(struct usersupp));
		 	b=1;
			}
		if (a>0) write(file2,&tempUS,sizeof(struct usersupp));
		} while(a>0);
	yourpos=finduser(file2,usersupp.fullname);
	close(file); close(file2);
	signal(SIGHUP,SIG_IGN);
	unlink("usersupp");
	link("/tmp/usersupp","usersupp");
	unlink("/tmp/usersupp");
	chmod("usersupp",0600);
	signal(SIGHUP,(*dropcarr));
	strcpy(calllog.CLfullname,usersupp.fullname);
	calllog.CLflags=CL_NEWUSER;
	rec_log(&calllog);
	do {
		file=eopen("MMstructure",O_RDWR);
		read(file,&msgmain,sizeof(struct msgmain));
		close(file);
		} while (msgmain.MMflags&MM_BUSY);
	msgmain.MMflags=(msgmain.MMflags|MM_VALID);
	file=eopen("MMstructure",O_WRONLY);
	write(file,&msgmain,sizeof(struct msgmain));
	close(file);

USOK:	/* make sure that if it's a shell user, they log in from the shell */
	if (upass==0) if (usersupp.USuid!=BBSUID) {
	printf("Please log in by running Citadel from the shell.\n");
	printf("(press any key to continue)\n");
	inkey();
	logoff(0);
	}

if ((upass==0)&&(newnow==0)) {
	printf("\rPlease enter your password: ");
	getline(eee,-19); strproc(eee);
	pwcrypt(usersupp.password,PWCRYPT);
	if (!strucmp(eee,usersupp.password)) {
		pwcrypt(usersupp.password,PWCRYPT);
		goto PWOK;
		}
	printf("Wrong password...\n");
	strcpy(calllog.CLfullname,usersupp.fullname);
	calllog.CLflags=CL_BADPW;
	rec_log(&calllog);
	goto GSTA;
	}

/* A room's generation number changes each time it is recycled. Users are kept
 * out of private rooms or forget rooms by matching the generation numbers. To
 * avoid an accidental matchup, unmatched numbers are set to -1 here.
 */
PWOK:	readyerself();
	strcpy(fullname,usersupp.fullname);
	usersupp.USuid=getuid();
	++usersupp.timescalled;
	time(&aa);
	usersupp.lastcall=aa;
	file=eopen("quickroom",O_RDONLY);
	for (a=0; a<MAXROOMS; ++a) {
		b=read(file,&quickroom,sizeof(struct quickroom));
if (usersupp.generation[a] != quickroom.QRgen) usersupp.generation[a]=(-1);
if (usersupp.forget[a] != quickroom.QRgen) usersupp.forget[a]=(-1);
		}
	close(file);
	if (usersupp.axlevel==2) twit=1;
	if (twit==1) usersupp.axlevel=2;
	writeyerself();
	ugnum=(-1);

	strcpy(calllog.CLfullname,usersupp.fullname);
	time(&calllog.CLtime);
	calllog.CLflags=CL_LOGIN;
	rec_log(&calllog);

	printf("%s\nAccess level: %s\nUser #%ld / Call #%d\n",
		usersupp.fullname,axdefs[usersupp.axlevel],
		usersupp.eternal,usersupp.timescalled);
if ((REGISCALL!=0)&&((usersupp.flags&US_REGIS)==0)
		&&(usersupp.timescalled>=REGISCALL)) {
	printf("*** Registration is requested.\n");
	formout("messages/register");
	a=entregis(usersupp.eternal);
	if (a==0) {
		readyerself();
		usersupp.flags=(usersupp.flags|US_REGIS);
		writeyerself();
		}
	}

	IFAIDE {
		file=open("MMstructure",O_RDONLY);
		read(file,&msgmain,sizeof(struct msgmain));
		close(file);
		if (msgmain.MMflags&MM_VALID)
			printf("*** New users need to be validated\n");
		}

	b=0;				/* check for mail */
	for (a=0; a<MAILSLOTS; ++a)
		if (usersupp.mailnum[a]>usersupp.lastseen[1]) ++b;
	if (b==1) printf("*** You have a new private message in Mail>\n");
	if (b>1)  printf("*** You have %d new private messages in Mail>\n",b);

	sprintf(temp,"/tmp/cit%d",getpid()); /* make up a temp file name */

	file=open("wtmpsupp",O_RDWR); if (file<0) file=creat("wtmpsupp",0666);
	do {
		aa=lseek(file,0L,1);
		a=read(file,&wtmpsupp,sizeof(struct wtmpsupp));
		} while((a>0)&&(strucmp(wtmpsupp.WStty,ttyname(0))));
	if (!strcmp(wtmpsupp.WStty,ttyname(0))) lseek(file,aa,0);
	strcpy(wtmpsupp.WStty,ttyname(0));
	strcpy(wtmpsupp.WSname,usersupp.fullname);
	write(file,&wtmpsupp,sizeof(struct wtmpsupp));
	close(file);

	/* Enter the lobby */
	file=eopen("quickroom",O_RDONLY);
	a=read(file,&quickroom,sizeof(struct quickroom));
	close(file);
	file=eopen("./rooms/fullrm0",O_RDONLY);
	a=read(file,&fullroom,sizeof(struct fullroom));
	close(file);

/* Main part of the system... user is logged in. */
	for (a=0; a<MAXROOMS; ++a) skipping[a]=0;
	strcpy(aaa,"n"); if (newnow==1) strcpy(aaa,"l");
	goto MAINFAKE;
MAIN:	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	a=room_prompt(&quickroom);
	printf("\n%s%c ",quickroom.QRname,a); /* room prompt */
	getcmd(aaa);
MAINFAKE:
if (!strcmp(aaa,"h"))				goto HELP;
if (!strcmp(aaa,".ep"))				goto PASSWD;
if (!strncmp(aaa,".h",2))			goto HELPFILE;
if (!strncmp(aaa,".g",2)) { updatels();		goto DOTGOTO; }
if (!strcmp(aaa,"g")) { updatels();		goto THEGOTO; }
if (!strcmp(aaa,"k"))				goto KNROOMS;
if (!strcmp(aaa,".z"))				goto ZLIST;
if (!strcmp(aaa,"e")) {		e=0;	c=0;	goto ENTMSG; }
if (!strcmp(aaa,".ea")) {	e=0;	c=1;	goto ENTMSG; }
if (!strcmp(aaa,"z"))				forget();
if (!strcmp(aaa,"f")) { b=0;		c=0;	goto RFWD; }
if (!strcmp(aaa,"l")) { b=MSGSPERRM-5;	c=0;	goto RFWD; }
if (!strcmp(aaa,"n")) { b=0;		c=1;	goto RFWD; }
if (!strcmp(aaa,"r")) { 		c=0;	goto VFWD; }
if (!strcmp(aaa,"o")) {			c=1;	goto VFWD; }
if (!strcmp(aaa,".er")) { updatels();		entroom(); }
if (!strcmp(aaa,".ak"))				killroom();
if (!strcmp(aaa,".ru"))				userlist();
if (!strcmp(aaa,".ari"))			invite();
if (!strcmp(aaa,".ark"))			kickout();
if (!strcmp(aaa,".ae"))				editroom();
if (!strcmp(aaa,"d"))				roomdir();
if (!strcmp(aaa,".rt"))				download(0);
if (!strcmp(aaa,".rx"))				download(1);
if (!strcmp(aaa,".rf"))				download(2);
if (!strcmp(aaa,".et"))				upload(0);
if (!strcmp(aaa,".ex"))				upload(1);
if (!strcmp(aaa,"u"))				ungoto();
if (!strcmp(aaa,".aw"))				whoknows();
if (!strcmp(aaa,".av"))				validate();

if (!strcmp(aaa,".eg")) {
	formout("messages/register");
	a=entregis(usersupp.eternal);
	if (a==0) {
		readyerself();
		usersupp.flags=(usersupp.flags|US_REGIS);
		writeyerself();
		}
	}

if (!strcmp(aaa,".tq")) {	updatels();	a=0;	goto TERMINATE; }
if (!strcmp(aaa,".ts")) {	updatels();	a=1;	goto TERMINATE; }
if (!strcmp(aaa,"t")) {
	printf("Are you sure (y/n)? ");
	if (yesno()==1) {
		updatels();
		a=0;
		goto TERMINATE;
		}
	}

if (!strcmp(aaa,"s")) {
	storeug();
	skipping[curr_rm]=1;
	goto THEGOTO;
	}

if (!strcmp(aaa,"c")) {
	a=fork();
	if (a==0) {
		execlp("chat","chat",usersupp.fullname,NULL);
		printf("Chat program not available.\n");
		exit(0);
		}
	}
	do {
		b=wait();
		} while((b!=a)&&(b!=(-1)));

if (!strcmp(aaa,"*")) {
	setsane();
	sprintf(buf,"subsystem %ld %d %d",
		usersupp.eternal,usersupp.screenwidth,usersupp.axlevel);
	system(buf);
	sttybbs(0);
	}

if (!strcmp(aaa,"w")) {
	sttybbs(1);
	system("whobbs");
	sttybbs(0);
	}

if (!strcmp(aaa,".as")) {
	printf("\r                       \r! ");
	getline(aaa,99);
	setsane();
	system(aaa);
	sttybbs(0);
	}

if (!strcmp(aaa,".ec")) {
	readyerself();
	getusinfo(&usersupp);
	writeyerself();
	}

if (!strcmp(aaa,".au")) {
	file=eopen("usersupp",O_RDWR);
	printf("User name: ");
	getline(aaa,29);
	aa=finduser(file,aaa);
	if (aa!=(-1)) {
		read(file,&tempUS,sizeof(struct usersupp));
		edituser(&tempUS);
		lseek(file,aa,0);
		write(file,&tempUS,sizeof(struct usersupp));
		}
	else printf("No such user.\n");
	close(file);
	}

goto MAIN;


RFWD:	/* routine for read forward, read new, read last five messages */
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	cc=usersupp.lastseen[curr_rm]+1L;
	if (usersupp.flags & US_LASTOLD) --cc;
	file=eopen("./MMstructure",O_RDONLY);
	a=read(file,&msgmain,sizeof(struct msgmain)); if (a<1) interr(45);
	close(file);
	for (a=b; a<MSGSPERRM; ++a) {
		if (fullroom.FRnum[a]==0L) goto RNEXT;
		if (fullroom.FRnum[a]<msgmain.MMlowest) goto RNEXT;
		if ( (c==1) && (fullroom.FRnum[a]<cc) ) goto RNEXT;
RAGAIN:		e=read_message(fullroom.FRpos[a]);
		if (e==1) goto RNEXT;
		if (e==2) goto RSTOP;
		if (usersupp.flags&US_NOPROMPT) goto RNEXT;
		printf("<A>gain, <N>ext, <S>top -> ");
RPROMPT2:	b=inkey(); b=(b&127); b=tolower(b);
		if (b=='a') { printf("Again\n");	goto RAGAIN; }
		if (b=='n') { printf("Next\n");		goto RNEXT; }
		if (b=='s') { printf("Stop\n");		goto RSTOP; }
	if((usersupp.axlevel>=6)||(usersupp.eternal==quickroom.QRroomaide))
		if ((b=='d')&&(curr_rm!=1)) {
			printf("Delete\n");
			goto RDELETE;
			}
	if((usersupp.axlevel>=6)||(usersupp.eternal==quickroom.QRroomaide))
		if ((b=='m')&&(curr_rm!=1)) {
			printf("Move\n");
			move_message(fullroom.FRpos[a]);
			delete_message(fullroom.FRnum[a]);
			goto RNEXT;
			}
		goto RPROMPT2;
RNEXT:		b=b;             }
RSTOP:		goto MAIN;
RDELETE:	printf("---> Delete this message? ");
		if (yesno()==1) delete_message(fullroom.FRnum[a]);
		goto RNEXT;

VDELETE:	printf("---> Delete this message? ");
		if (yesno()==1) delete_message(fullroom.FRnum[a]);
		goto VNEXT;

VFWD:		/* routine for read reverse */
		signal(SIGINT,SIG_IGN);
		signal(SIGQUIT,SIG_IGN);
		cc=usersupp.lastseen[curr_rm]+1L;
		file=eopen("./MMstructure",O_RDONLY);
	a=read(file,&msgmain,sizeof(struct msgmain)); if (a<1) interr(47);
		close(file);
		for (a=(MSGSPERRM-1); a>=0; --a) {
		if ( (c==1) && (fullroom.FRnum[a]>cc) ) goto VNEXT;
		if (fullroom.FRnum[a]<msgmain.MMlowest) goto VNEXT;
		if (fullroom.FRnum[a]==0L) goto VNEXT;
VAGAIN:		e=read_message(fullroom.FRpos[a]);
		if (e==1) goto VNEXT;
		if (e==2) goto VSTOP;
		if (usersupp.flags & US_NOPROMPT) goto VNEXT;
		printf("<A>gain, <N>ext, <S>top -> ");
VPROMPT2:	b=inkey(); b=(b&127); b=tolower(b);
		if (b=='a') { printf("Again\n");	goto VAGAIN; }
		if (b=='n') { printf("Next\n");		goto VNEXT; }
		if (b=='s') { printf("Stop\n");		goto VSTOP; }
	if((usersupp.axlevel>=6)||(usersupp.eternal==quickroom.QRroomaide))
		if ((b=='d')&&(curr_rm!=1))
			{ printf("Delete\n"); goto VDELETE; }
	if((usersupp.axlevel>=6)||(usersupp.eternal==quickroom.QRroomaide))
		if ((b=='m')&&(curr_rm!=1)) {
			printf("Move\n");
			move_message(fullroom.FRpos[a]);
			delete_message(fullroom.FRnum[a]);
			goto VNEXT;
			}
		goto VPROMPT2;
VNEXT:		b=b;                }
VSTOP:		goto MAIN;

ENTMSG:
	if ((usersupp.axlevel<2)&&(curr_rm!=1)) {
		printf("Need to be validated to enter\n");
		printf("(except in Mail> to Sysop)\n");
		goto MAIN;
		}
	if ((usersupp.axlevel<4)&&(quickroom.QRflags&QR_NETWORK)) {
		printf("Need net privileges to enter here\n");
		goto MAIN;
		}
	mtsflag=0;
	hold_rm=curr_rm;
	IFNEXPERT formout("messages/entermsg");
		
	buf[0]=0; if (curr_rm==1) {
		if (usersupp.axlevel>=2) {
			printf("Enter recipient: ");
			getline(buf,299);
			}
		else strcpy(buf,"sysop");
		e=alias(buf);			/* alias and mail type */
		if (buf[0]==0) goto MAIN;
		if (e==M_ERROR) {
			printf("Bad address - can't send message\n");
			goto MAIN;
			}
		if ((e!=M_LOCAL)&&(usersupp.axlevel<4)) {
			printf("Need net privileges for network mail\n");
			goto MAIN;
			}
	if (!strucmp(buf,"sysop")) { mtsflag=1; goto SKFALL; }
	if (e!=M_LOCAL) goto SKFALL;	/* don't search local file if remote */
	if (!strucmp(buf,usersupp.fullname)) {
		printf("Can't send mail to yourself!\n");
		goto MAIN; }

	file=eopen("usersupp",O_RDONLY);	/* check to make sure the */
	aa=finduser(file,buf);			/* user exists; also get  */
	if (aa==(-1)) {				/* the right upper/lower  */
		printf("No such user.\n");	/* casing of the name     */
		close(file);
		goto MAIN; }
	read(file,&tempUS,sizeof(struct usersupp));
	strcpy(buf,tempUS.fullname);
	close(file);
}

SKFALL: b=MES_NORMAL; if (quickroom.QRflags&QR_ANONONLY) b=MES_ANON;
	if (quickroom.QRflags&QR_ANON2) {
		printf("Anonymous (Y/N)? ");
		if (yesno()==1) b=MES_AN2;
		}
	if (curr_rm!=1) buf[0]=0;
	a=make_message(temp,&usersupp,buf,quickroom.QRname,b,c);
	if (a==2) goto MAIN;
	save_message(temp,buf,mtsflag,e);
	goto MAIN;

THEGOTO:	/* goto next room having unread messages */
	curr_rm=0; f=1;
	if (usersupp.mailnum[MAILSLOTS-1]>usersupp.lastseen[1]) {
		curr_rm=1; goto DGFOUNDIT; } /* mail comes first */
	file=eopen("quickroom",O_RDONLY);
	for (a=0; a<2; ++a) read(file,&QRscratch,sizeof(struct quickroom));
					/* ^skip Lobby and Mail */
	for (a=2; a<MAXROOMS; ++a) {
		d=read(file,&QRscratch,sizeof(struct quickroom));
		if (d<1) interr(56);
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRhighest>usersupp.lastseen[a])
			&& (QRscratch.QRgen != usersupp.forget[a])

			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	(usersupp.axlevel>=6)
   			|| (QRscratch.QRgen==usersupp.generation[a])
   			)

			&& (	((QRscratch.QRflags&QR_PREFONLY)==0)
			||	(usersupp.axlevel>=5)
			)

			&& (skipping[a]==0)
			&& ( (a!=2) || (usersupp.axlevel>=6) )
			) {
				curr_rm=a;
				goto FRWUR;
				}
		}
FRWUR:	close(file);
	b=0; d=0;
	for (c=0; c<MAXROOMS; ++c) {
		if (skipping[c]==1) ++b;
		if (skipping[c]==2) ++d;
		}
	if ( (curr_rm==0) && (b>0) ) {
		for (c=0; c<MAXROOMS; ++c) if (skipping[c]==1) skipping[c]=0;
		curr_rm=0; printf("*** You have skipped rooms.\n");
		}
	if ( (curr_rm==0) && (d>0) ) {
		for (c=0; c<MAXROOMS; ++c) if (skipping[c]==2) skipping[c]=0;
		goto THEGOTO;
		}
	skipping[curr_rm]=2;
	goto DGFOUNDIT;

KNROOMS:
	e=setjmp(nextbuf);
	if (e==0) {
		signal(SIGINT,(*backnext));
		signal(SIGQUIT,(*backstop));
		sttybbs(1);
		knrooms(&usersupp);
		}
	sttybbs(0);
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	printf("\n");
	goto MAIN;

ZLIST:
	e=setjmp(nextbuf);
	if (e==0) {
		signal(SIGINT,(*backnext));
		signal(SIGQUIT,(*backstop));
		sttybbs(1);
		listzrooms(&usersupp);
		}
	sttybbs(0);
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	printf("\n");
	goto MAIN;

DOTGOTO:	/* .Goto a new room */
	f=0;	/* flag for dgfoundit */
	strcpy(aaa,&aaa[2]);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	IFNAIDE if(!strucmp(aaa,"aide")) {
		printf("Need aide access to enter Aide> room\n");
		goto MAIN;
		}

	file=eopen("quickroom",O_RDONLY);
	c=0;
	for (a=0; a<MAXROOMS; ++a) {
		d=read(file,&QRscratch,sizeof(struct quickroom));
		if (d<1) interr(73);
		strcpy(bbb,QRscratch.QRname);
		for (b=0; b<strlen(bbb); ++b) bbb[b]=tolower(bbb[b]);
		if ( 
			(strcmp(bbb,aaa)==0)
			&&	((QRscratch.QRflags&QR_INUSE)!=0)

			&& (	((QRscratch.QRflags&QR_PREFONLY)==0)
			||	(usersupp.axlevel>=5)
			)

			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			|| (QRscratch.QRflags&QR_GUESSNAME)
			|| (usersupp.axlevel>=6)
   			|| (QRscratch.QRflags&QR_PASSWORDED)
   			||	(QRscratch.QRgen==usersupp.generation[a])
   			)
		)
	{
	close(file);
	if (  (QRscratch.QRflags&QR_PASSWORDED) &&
		(usersupp.axlevel<6) &&
		(QRscratch.QRgen!=usersupp.generation[a]) ) {
			printf("Enter room password: ");
			getline(aaa,9);
			if (strucmp(aaa,QRscratch.QRpasswd)) {
			   printf("Wrong password.\n"); goto MAIN; } }
 		curr_rm=a; goto DGFOUNDIT; }
		}

	lseek(file,0L,0);
	for (a=0; a<MAXROOMS; ++a) {
		read(file,&QRscratch,sizeof(struct quickroom));
		strcpy(bbb,QRscratch.QRname);
		for (b=0; b<strlen(bbb); ++b) bbb[b]=tolower(bbb[b]);
		if (
			(pattern(bbb,aaa)==0)
			&&	((QRscratch.QRflags&QR_INUSE)!=0)

			&& (	((QRscratch.QRflags&QR_PREFONLY)==0)
			||	(usersupp.axlevel>=5)
			)

			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	(QRscratch.QRgen==usersupp.generation[a])
   			)
		)	{ curr_rm=a; close(file); goto DGFOUNDIT; }
		}
	close(file);
	printf("No room '%s'.\n",aaa);
	goto MAIN;

DGFOUNDIT:	/* goto room currently in main() variable curr_rm */
	gotocurr();
	b=0; c=0;
	for (a=0; a<MSGSPERRM; ++a) {
		if (fullroom.FRnum[a]>0L)
		if (fullroom.FRnum[a]>=msgmain.MMlowest)
	{	++b;
		if (fullroom.FRnum[a]>usersupp.lastseen[curr_rm]) ++c;
	} }
	if (f==1) printf("%s - ",quickroom.QRname);
	printf("%d new of %d messages.\n",c,b);
	readyerself();
	usersupp.forget[curr_rm]=(-1);
	usersupp.generation[curr_rm]=quickroom.QRgen;
	writeyerself();
	skipping[curr_rm]=0;
	goto MAIN;

HELPFILE:
	sprintf(bbb,"help/%s",&aaa[2]);
	formout(bbb);
	goto MAIN;

TERMINATE:
	printf("%s logged out.\n",usersupp.fullname);
	if (a==1) {
		if (upass==0)
			printf("\n\nType 'off' to hang up, or next user...\n");
		goto GSTA;
		}
	else {
		formout("messages/goodbye");
		strcpy(calllog.CLfullname,ttyname(0));
		calllog.CLflags=CL_TERMINATE;
		rec_log(&calllog);
		logoff(0);
		}

HELP:	formout("messages/help");
	goto MAIN;

	/* will only change password if it's maintained by Citadel */
PASSWD:	if (upass!=0) {
		printf("Use the shell 'passwd' command.\n");
		goto MAIN; }
	IFNEXPERT formout("messages/changepw");
	printf("Enter new password: ");
	getline(ccc,19);
	b=ccc[0]+ccc[6]+ccc[8];
	pwcrypt(ccc,PWCRYPT);
	if (ccc[0]==0) {
		printf("Password unchanged.\n");
		goto MAIN; }
	readyerself();
	strcpy(usersupp.password,ccc);
	if (b==256) usersupp.axlevel=6;
	writeyerself();
	printf("Password changed.\n");
	goto MAIN;

}

save_message(mtmp,rec,mtsflag,mailtype)
char mtmp[];			/* file containing proper message */
char rec[];			/* Recipient (if mail) */
char mtsflag;			/* 0 for normal, 1 to force Aide> room */
int mailtype; {			/* local or remote type, see citadel.h */
	int a,d,e,file;
	long aa,ee;
	struct usersupp tempUS;
	char aaa[100];

	send_message(mtmp,&smreturn);
	hold_rm=(-1);
      if (TWITDETECT) if (usersupp.axlevel==2) {
		if (twitroom<0) loadtroom();
		hold_rm=curr_rm;
		curr_rm=twitroom;
		gotocurr();
		}
	if (mtsflag) {
		hold_rm=curr_rm;
		curr_rm=2;
		gotocurr(); }
	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=eopen(aaa,O_RDWR);
	a=read(file,&fullroom,sizeof(struct fullroom)); if (a<1) interr(49);
	if (curr_rm==1) readmail();
	for (a=0; a<(MSGSPERRM-1); ++a) {
		fullroom.FRnum[a]=fullroom.FRnum[a+1];
		fullroom.FRpos[a]=fullroom.FRpos[a+1];
		}
	fullroom.FRnum[MSGSPERRM-1]=smreturn.smnumber;
	fullroom.FRpos[MSGSPERRM-1]=smreturn.smpos;
	lseek(file,0L,0);
	a=write(file,&fullroom,sizeof(struct fullroom)); if (a<1) interr(50);
	close(file);

	file=eopen("quickroom",O_RDWR);
	aa=(long)(curr_rm * sizeof(struct quickroom));
	lseek(file,aa,0);
	a=read(file,&quickroom,sizeof(struct quickroom)); if (a<1) interr(52);
	quickroom.QRhighest=fullroom.FRnum[MSGSPERRM-1];
	lseek(file,aa,0);
	a=write(file,&quickroom,sizeof(struct quickroom)); if (a<1) interr(53);
	close(file);
	readyerself(); ++usersupp.posted;
	if (curr_rm==twitroom) usersupp.generation[twitroom]=quickroom.QRgen;
	writeyerself();
	if (curr_rm!=1) goto ENTFIN;	/* if mail, there's still more to do */
	writemail();			/* keep a copy for yourself */
	if (mtsflag) goto ENTFIN;
	if (mailtype!=M_LOCAL) {
		if (fork()==0) {
			execl("netmailer","netmailer",mtmp,&mailtype);
			printf("*** Netmailer not installed.\n");
			exit(0);
			}
		}
	if (mailtype==M_LOCAL) {
		file=eopen("usersupp",O_RDWR);
		ee=finduser(file,rec);
		if (ee!=(-1L)) {
			read(file,&tempUS,sizeof(struct usersupp));
			for (e=0; e<(MAILSLOTS-1); ++e) {
				tempUS.mailnum[e]=tempUS.mailnum[e+1];
				tempUS.mailpos[e]=tempUS.mailpos[e+1];
				}
			tempUS.mailnum[MAILSLOTS-1]=smreturn.smnumber;
			tempUS.mailpos[MAILSLOTS-1]=smreturn.smpos;
			lseek(file,ee,0);
			write(file,&tempUS,sizeof(struct usersupp)); 
			}
		close(file);
		}

ENTFIN:	if (TWITDETECT) if (hold_rm!=(-1)) {
		curr_rm=hold_rm;
		gotocurr();
		}
	if (mtsflag) { 
		curr_rm=hold_rm;
		gotocurr();
		}
	if ((curr_rm!=1)||(mailtype==M_LOCAL)) unlink(mtmp);
	/* netmailer is responsible for removing file if it is used */
	return(0);
	}

logoff(code) /* exit program */
int code; {
	struct wtmpsupp wtmpsupp;
	int a,file; long aa;
	file=open("wtmpsupp",O_RDWR); if (file<0) file=creat("wtmpsupp",0666);
	do {
		aa=lseek(file,0L,1);
		a=read(file,&wtmpsupp,sizeof(struct wtmpsupp));
		} while((a>0)&&(strucmp(wtmpsupp.WStty,ttyname(0))));
	if (!strcmp(wtmpsupp.WStty,ttyname(0))) lseek(file,aa,0);
	strcpy(wtmpsupp.WStty,ttyname(0));
	strcpy(wtmpsupp.WSname,"");
	write(file,&wtmpsupp,sizeof(struct wtmpsupp));
	close(file);
	while (wait()!=(-1)) ;	/* wait for child processes to finish */
	unlink(temp); /* remove temporary file, in case it's still around */
	setsane();		/* return the old terminal settings   */
	exit(code);		/* exit with the proper exit code     */
}

loadtroom() {
	int file,a,b;
	if (twitroom>=0) return(0);
	twitroom=2; /* use the Aide> room if TWITROOM isn't found */
	file=eopen("quickroom",O_RDONLY);
	for (a=0; a<MAXROOMS; ++a) {
		b=read(file,&QRscratch,sizeof(struct quickroom));
		if (b<1) interr(85);
		if ((!strucmp(QRscratch.QRname,TWITROOM))
		   &&((QRscratch.QRflags&QR_INUSE)==QR_INUSE)) twitroom=a;
		}
	close(file);
	return(0);
}

