/*
 * Citadel/UX
 *
 * commands.c - Command parser for room prompts
 *
 */

#include <stdio.h>
#include <ctype.h>
#include "citadel.h"

#define IFAIDE if(usersupp.axlevel>=6)
#define IFNAIDE if (usersupp.axlevel<6)
struct passwd *getpwuid();
long lseek();

extern struct usersupp usersupp;
extern int curr_rm;
extern struct quickroom quickroom;

getcmd(string) /* Parses an input command, also translates synonyms */
char string[]; {
int a;
strcpy(string,"");
GCA:a=inkey();
a=tolower(a);
if (a=='?') a='h';
if (a=='*') {
	printf("SubSystem\n");
	strcpy(string,"*");
	return(0); }
if (a=='c') {
	printf("Chat\n");
	strcpy(string,"c");
	return(0); }
if (a=='h') {
	printf("Help!\n");
	strcpy(string,"h");
	return(0); }
if (a=='e') {
	printf("Enter Message\n");
	strcpy(string,"e");
	return(0); }
if (a=='g') {
	printf("Goto\n");
	strcpy(string,"g");
	return(0); }
if (a=='s') {
	printf("Skip %s\n",quickroom.QRname);
	strcpy(string,"s");
	return(0); }
if (a=='z') {
	printf("Zap (forget) room\n");
	strcpy(string,"z");
	return(0); }
if (a=='k') {
	printf("Known Rooms\n");
	strcpy(string,"k");
	return(0); }
if (a=='l') {
	printf("Read last five messages\n");
	strcpy(string,"l");
	return(0); }
if (a=='f') {
	printf("Read Forward\n");
	strcpy(string,"f");
	return(0); }
if (a=='r') {
	printf("Read Reverse\n");
	strcpy(string,"r");
	return(0); }
if (a=='o') {
	printf("read Old reverse\n");
	strcpy(string,"o");
	return(0); }
if (a=='n') {
	printf("Read New\n");
	strcpy(string,"n");
	return(0); }
if (a=='d') {
	printf("read Directory\n");
	strcpy(string,"d");
	return(0); }
if (a=='t') {
	printf("Terminate\n");
	strcpy(string,"t");
	return(0); }
if (a=='u') {
	printf("Ungoto\n");
	strcpy(string,"u");
	return(0); }
if (a=='w') {
	printf("Who's online...\n");
	strcpy(string,"w");
	return(0); }
if (a=='.') {
	printf(".");
	goto DOT; }
IFAIDE if ((a=='!')&&(getuid()==geteuid())) {
	printf("! ");
	strcpy(string,".as");
	return(0); }
goto GCA;
DOT: a=inkey(); a=tolower(a);
if (a==8) {
        back(1);
   	goto GCA; }
if (a=='r') {
	printf("Read ");
	goto GCREAD; }
if (a=='e') {
	printf("Enter ");
	goto GCENT; }
if (a=='k') {
	printf("Known rooms\n");
	strcpy(string,"k");
	return(0); }
if (a=='t') {
	printf("Terminate ");
	goto GCTERM; }
if (a=='z') {
	printf("Zapped list\n");
	strcpy(string,".z");
	return(0); }
if ( (usersupp.axlevel>=6) || (usersupp.eternal==quickroom.QRroomaide) )
	if (a=='a') {
		printf("Aide cmd: ");
		goto GCAIDE; }
if (a=='g') {
	  printf("Goto Room: ");
	  strcpy(string,".g");
	  getline(&string[2],19);
	  return(0); }
     if (a=='h') {
          printf("Help File: ");
          strcpy(string,".h");
          getline(&string[2],15);
          return(0); }
     goto DOT;

GCAIDE:	a=inkey(); a=tolower(a);
	if (a=='?') {
		printf("(aide options)\n");
		formout("messages/aideopt");
		printf("%s> .Aide cmd: ",quickroom.QRname);
		goto GCAIDE; }
	if (a==8) { back(10); goto DOT; }
	if (a=='r') {
		printf("Room cmd: ");
		goto ROOMCMD; }
	if (a=='k') {
		printf("Kill this room\n");
		strcpy(string,".ak");
		return(0); }
	if (a=='e') {
		printf("Edit room\n");
		strcpy(string,".ae");
		return(0);
		}
	if (a=='w') {
		printf("Who knows room\n");
		strcpy(string,".aw");
		return(0);
		}
	if ( (usersupp.axlevel>=6) && (a=='u')) {
		printf("User edit\n");
		strcpy(string,".au");
		return(0);
		}
	if ( (usersupp.axlevel>=6) && (a=='v')) {
		printf("Validate new users\n");
		strcpy(string,".av");
		return(0);
		}
	goto GCAIDE;

ROOMCMD:
	a=inkey(); a=tolower(a);
	if (a==8) { back(10); goto GCAIDE; }
	if (a=='i') {
		printf("Invite user\n");
		strcpy(string,".ari");
		return(0); }
	if (a=='k') {
		printf("Kick out user\n");
		strcpy(string,".ark");
		return(0); }
	goto ROOMCMD;

GCTERM:	a=inkey(); a=tolower(a);
	if (a==8) { back(10); goto DOT; }
	if (a=='q') {
		printf("and Quit\n");
		strcpy(string,".tq");
		return(0); }
	if (a=='s') {
		printf("and Stay\n");
		strcpy(string,".ts");
		return(0); }
	goto GCTERM;

GCREAD:	a=inkey(); a=tolower(a);
	if (a=='?') {
		printf("(options)\n");
		formout("messages/readopt");
		printf("%s> .Read ",quickroom.QRname);
		goto GCREAD; }
	if (a==8) { back(5); goto DOT; }
if (a=='f') {
	printf("File unformatted\n");
	strcpy(string,".rf");
	return(0); }
if (a=='r') {
	printf("Reverse\n");
	strcpy(string,"r");
	return(0); }
if (a=='n') {
	printf("New messages\n");
	strcpy(string,"n");
	return(0); }
if (a=='o') {
	printf("Old messages reverse\n");
	strcpy(string,"o");
	return(0); }
if (a=='l') {
	printf("Last five messages\n");
	strcpy(string,"l");
	return(0); }
if (a=='u') {
	printf("User List\n");
	strcpy(string,".ru");
	return(0); }
if (a=='d') {
	printf("Directory\n");
	strcpy(string,"d");
	return(0); }
if (a=='t') {
	printf("Textfile formatted\n");
	strcpy(string,".rt");
	return(0); }
if (a=='x') {
	printf("file with Xmodem\n");
	strcpy(string,".rx");
	return(0); }
	goto GCREAD;

GCENT:a=inkey(); a=tolower(a);
	if (a=='?') {
		printf("(options)\n");
		formout("messages/entopt");
		printf("%s> .Enter ",quickroom.QRname);
		goto GCENT; }
	if (a==8) {
		back(6);
		goto DOT; }
if (a=='p') {
     printf("Password\n");
     strcpy(string,".ep");
     return(0); }
if (a=='m') {
	printf("Message\n");
	strcpy(string,"e");
	return(0); }
if (a=='a') {
	printf("message using ASCII\n");
	strcpy(string,".ea");
	return(0); }
if (a=='c') {
	printf("Configuration\n");
	strcpy(string,".ec");
	return(0); }
if (a=='r') {
     printf("a new Room\n");
     strcpy(string,".er");
     return(0); }
if (a=='t') {
     printf("Textfile\n");
     strcpy(string,".et");
     return(0); }
if (a=='x') {
     printf("file with Xmodem\n");
     strcpy(string,".ex");
     return(0); }
if (a=='g') {
     printf("reGistration\n");
     strcpy(string,".eg");
     return(0); }
goto GCENT;
}
